*$ CREATE SOURCE.FOR
*COPY SOURCE
*
*=== source ===========================================================*
*
      SUBROUTINE SOURCE ( NOMORE )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2009      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     New source for FLUKA9x-FLUKA20xy:                                *
*                                                                      *
*     Created on 07 january 1990   by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on 08-feb-09     by    Alfredo Ferrari               *
*                                                                      *
*  This is just an example of a possible user written source routine.  *
*  note that the beam card still has some meaning - in the scoring the *
*  maximum momentum used in deciding the binning is taken from the     *
*  beam momentum.  Other beam card parameters are obsolete.            *
*                                                                      *
*       Output variables:                                              *
*                                                                      *
*              Nomore = if > 0 the run will be terminated              *
*                                                                      *
*----------------------------------------------------------------------*
*

      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'
      INCLUDE 'flukaio.inc'

      LOGICAL LFIRST

      SAVE LFIRST
      DATA LFIRST / .TRUE. /

      CHARACTER*13 FILNAM
      SAVE FILNAM
      DATA FILNAM / 'coupling.stop' /

      LOGICAL LEXIST
      SAVE LEXIST
      DATA LEXIST / .FALSE. /
      
      INTEGER ICOUNT, ITOTAL
      COMMON /TRACKING/ ICOUNT, ITOTAL
      
      INTEGER IPRINT
      LOGICAL LPRINT
     

*======================================================================*
*                                                                      *
*                 BASIC VERSION                                        *
*                                                                      *
*======================================================================*
      NOMORE = 0
*  +-------------------------------------------------------------------*
*  |  First call initializations:
      IF ( LFIRST ) THEN
*  |  *** The following 3 cards are mandatory ***
         TKESUM = ZERZER
         LFIRST = .FALSE.
         LUSSRC = .TRUE.
*  |  *** User initialization ***

*        Server Initialization

         IPORT  = 0  ! Random assigned
         ITOTAL = 0
         ICOUNT = 0
         ITURN  = 0

	 IPORT = 12345
         IPORT = NTSTART(IPORT)
         if (IPORT .EQ. -1 ) THEN
           WRITE(LUNOUT,*) ' Error initializing server'
           CALL FLUSH(LUNOUT)
           GOTO 3900
         END IF

         WRITE(LUNOUT,*) ' '
         WRITE(LUNOUT,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(LUNOUT,*) ' !!       FlukaIO server initialized     !!'
         WRITE(LUNOUT,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         WRITE(LUNOUT,*) ' '
         WRITE(LUNOUT,*) ' Listening on port ', IPORT
         WRITE(LUNOUT,*) ' '
         WRITE(LUNOUT,*) ' To stop the simulation, touch file: '//
     &                   FILNAM
         WRITE(LUNOUT,*) ' '

*        Write server parameters
         CALL OAUXFI( '../network.nfo', 95, 'APPEND', IERR )
         WRITE(95,*) IPORT                 ! Port number where the server is listening
         CALL FFLUSH
         CALL FLUSH(95)
         CLOSE(95)

*        parse configuration file:
c         CALL PARSECONF()

*        Initialize scrapers
c         CALL SCR_INIT()

*        Accept network connection
         WRITE(LUNOUT,*) ' Waiting for connection'
         CALL FLUSH(LUNOUT)

         ICID = NTACCEPT()
         IF (ICID .lt. 0) THEN
           WRITE(LUNOUT,*) ' Error accepting connection'
           CALL FLUSH(LUNOUT)
           GOTO 3800
         END IF

c         NTTIMEOUT(ICID, 10000)
         WRITE(LUNOUT,*) ' Connection accepted'
         CALL FLUSH(LUNOUT)

      END IF ! End of initialization

 1972 CONTINUE ! Next message

* A.Mereghetti, 04/05/2011
* since BEAMPOS card is used, X/Y/Z/U/V/WBEAM are used
*       as expected:
        N = NTWAIT(
     &        ICID,
     &        MTYPE, 
     &        IDP, IDGEN, WGT, 
     &        XCBEAM, YCBEAM, ZCBEAM, 
     &        UCBEAM, VCBEAM, WCBEAM,
     &        IAA, IZZ, AMBEAM, PCBEAM,
     &        T)
        if(n.lt.0) then
          write(LUNOUT,*) 'Client timeout'
          CALL FLUSH(LUNOUT)
          goto 3900
        end if

*A enlever...
*       WRITE(LUNOUT,*)'PARAM: ', ICID, MTYPE, ITURN,
*     &  IDP,IDGEN, WGT, XCBEAM, YCBEAM, ZCBEAM,
*     &  UCBEAM, VCBEAM, WCBEAM, IAA, IZZ,
*     &  AMBEAM, PCBEAM 

* +--   Parse message type and act consecuently
* |
        IF(MTYPE.EQ.N_PART) THEN
c         Particle read, continue processing
          goto 3000
        end if

        IF(MTYPE.EQ.N_TURN) THEN
          goto 3100
        end if
        
        IF(MTYPE.EQ.N_END) THEN
          write(LUNOUT,*) '  Read end of computation'
          goto 3700
        end if
* |
* +--   End of message parsing
      

3000  continue ! A particle was read
*  |
*  +-------------------------------------------------------------------*
*  Push one source particle to the stack. Note that you could as well
*  push many but this way we reserve a maximum amount of space in the
*  stack for the secondaries to be generated

*     First particle of the turn, start of turn
      IF(ICOUNT.EQ.0) THEN

c       User requested run stop by creating coupling.stop file
        INQUIRE ( FILE = FILNAM, EXIST = LEXIST )
        IF (LEXIST) goto 4200 ! Inform error and close
        
*       Scraper start of turn
c        CALL SCR_SOT()
      END IF

* Npflka is the stack counter: of course any time source is called it
* must be =0
      NPFLKA = NPFLKA + 1
      ICOUNT = ICOUNT + 1

* Wt is the weight of the particle
      WTFLK  (NPFLKA) = ONEONE
      WEIPRI = WEIPRI + WTFLK (NPFLKA)

* Particle type (1=proton.....). Ijbeam is the type set by the BEAM
* card
*  +-------------------------------------------------------------------*
*  |  (Radioactive) isotope:
      IF ( IJBEAM .EQ. -2 .AND. LRDBEA ) THEN
         IARES  = IPROA
         IZRES  = IPROZ
         IISRES = IPROM
         CALL STISBM ( IARES, IZRES, IISRES )
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
*  |
*  +-------------------------------------------------------------------*
*  |  Heavy ion:
      ELSE IF ( IJBEAM .EQ. -2 ) THEN
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
         ILOFLK (NPFLKA) = IJHION
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
*  |  Group number for "low" energy neutrons, set to 0 anyway
         IGROUP (NPFLKA) = 0
*  |
*  +-------------------------------------------------------------------*
*  |  Normal hadron:
      ELSE
         IONID = IJBEAM
         ILOFLK (NPFLKA) = IJBEAM
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
*  |  Group number for "low" energy neutrons, set to 0 anyway
         IGROUP (NPFLKA) = 0
      END IF
*  |
*  +-------------------------------------------------------------------*



* From this point .....
* Particle generation (1 for primaries)
      LOFLK  (NPFLKA) = 1
* User dependent flag:
      LOUSE  (NPFLKA) = 0
*  No channeling:
      LCHFLK (NPFLKA) = .FALSE.
      DCHFLK (NPFLKA) = ZERZER
* User dependent spare variables:
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = ZERZER
 100  CONTINUE
* User dependent spare flags:
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = 0
 200  CONTINUE
* Save the track number of the stack particle:
      ISPARK (MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR (NPFLKA) = NPARMA
      NEVENT (NPFLKA) = 0
      DFNEAR (NPFLKA) = +ZERZER
* ... to this point: don't change anything
* Particle age (s)
      AGESTK (NPFLKA) = +ZERZER
      AKNSHR (NPFLKA) = -TWOTWO
* Kinetic energy of the particle (GeV)
      TKEFLK (NPFLKA) = SQRT ( PCBEAM**2 + AMBEAM**2 ) - AMBEAM
* Particle momentum
      PMOFLK (NPFLKA) = PCBEAM
* Cosines (tx,ty,tz)
      TXFLK  (NPFLKA) = UCBEAM
      TYFLK  (NPFLKA) = VCBEAM
      TZFLK  (NPFLKA) = WCBEAM
* Polarization cosines:
      TXPOL  (NPFLKA) = -TWOTWO
      TYPOL  (NPFLKA) = +ZERZER
      TZPOL  (NPFLKA) = +ZERZER
* Particle coordinates
      XFLK   (NPFLKA) = XBEAM + XCBEAM
      YFLK   (NPFLKA) = YBEAM + YCBEAM
      ZFLK   (NPFLKA) = ZBEAM + ZCBEAM

*Test, a enlever apres!!!

*      WRITE(LUNOUT,*)'Coordonnees:',XFLK (NPFLKA), YFLK (NPFLKA),
*     &  ZFLK (NPFLKA), ZBEAM, ZCBEAM

*
* A.Mereghetti, 19/02/2010
* the fort.99 file is written every IPRINT revolutions, as 
*     requested from the config.txt file:
      IF ( LPRINT ) THEN
*        first turn: print anyway
         IF ( ITURN .EQ. 1 ) THEN
            WRITE(99,'(2i7,1p,6(1x,e16.9))') IDP,ITURN,
     &          XFLK(NPFLKA),YFLK(NPFLKA),
     &          TXFLK(NPFLKA),TYFLK(NPFLKA),TZFLK(NPFLKA),TKEFLK(NPFLKA)
            CALL FLUSH(99)
            
*        moving scraper?
c         ELSEIF ( LMVSCR ) THEN
*           print if:
c            IF ( (  MOD( ITURN, IPRINT ).EQ.1 .AND. 
c     &          ( ITURN .GE. ISCINS ) ) .OR.
c     &          ( IPRINT .EQ. 1 ) ) THEN 
c               WRITE(99,'(2i7,1p,6(1x,e16.9))') IDP,ITURN,
c     &              XFLK(NPFLKA),YFLK(NPFLKA),
c     &              TXFLK(NPFLKA),TYFLK(NPFLKA),TZFLK(NPFLKA),
c     &              TKEFLK(NPFLKA)
c               CALL FLUSH(99)
c            ENDIF
          
*        not moving scraper?
         ELSEIF ( ( MOD( ITURN, IPRINT ).EQ.1 ) .OR.
     &          ( IPRINT .EQ. 1 ) ) THEN
            WRITE(99,'(2i7,1p,6(1x,e16.9))') IDP,ITURN,
     &          XFLK(NPFLKA),YFLK(NPFLKA),
     &          TXFLK(NPFLKA),TYFLK(NPFLKA),TZFLK(NPFLKA),TKEFLK(NPFLKA)
            CALL FLUSH(99)
         ENDIF
      ENDIF
*
*  Calculate the total kinetic energy of the primaries: don't change
      IF ( ILOFLK (NPFLKA) .EQ. -2 .OR. ILOFLK (NPFLKA) .GT. 100000 )
     &   THEN
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      ELSE IF ( ILOFLK (NPFLKA) .NE. 0 ) THEN
         TKESUM = TKESUM + ( TKEFLK (NPFLKA) + AMDISC (ILOFLK(NPFLKA)) )
     &          * WTFLK (NPFLKA)
      ELSE
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      END IF
      RADDLY (NPFLKA) = ZERZER


*  Here we ask for the region number of the hitting point.
*     NREG (NPFLKA) = ...
*  The following line makes the starting region search much more
*  robust if particles are starting very close to a boundary:
      CALL GEOCRS ( TXFLK (NPFLKA), TYFLK (NPFLKA), TZFLK (NPFLKA) )
      CALL GEOREG ( XFLK  (NPFLKA), YFLK  (NPFLKA), ZFLK  (NPFLKA),
     &              NRGFLK(NPFLKA), IDISC )


*  Do not change these cards:
      CALL GEOHSM ( NHSPNT (NPFLKA), 1, -11, MLATTC )
      NLATTC (NPFLKA) = MLATTC
      CMPATH (NPFLKA) = ZERZER
      CALL SOEVSV

!     Scraper particle
!     statistics on received particles
c      CALL SCR_PART(XCBEAM, YCBEAM, ZCBEAM, UCBEAM, VCBEAM, WCBEAM)

      ! Skip the rest, return with the particle
      RETURN

3100  continue ! End of turn
      ITURN = IDP
c      CALL SCR_EOT()
      N = NTSENDEOT(ICID, ITURN)

      write(LUNOUT,*) '  End of turn ', ITURN, ' received ', ICOUNT, 
     &                ' particles'

      ITOTAL = ITOTAL + ICOUNT
      ICOUNT = 0

      ! iterate again
      goto 1972


3700  continue ! the tracking is over, FLUKA is going to end

      write(LUNOUT,*) '** Sending end of connection'
      N = NTSENDEOC(ICID)

c      CALL SCR_EOC()

3800  continue ! Close connection

      write(LUNOUT,*) '** Closing connection'
      N = NTEND(ICID)
      ICID = -1

3900  continue ! Close server

      write(LUNOUT,*) '** Shuting server down'
      N = NTSHDWN()
      NOMORE = 1

      IF (ITOTAL.eq.0) THEN
        write(LUNOUT, *) '** 0 Particles received STOPPING Fluka'
        STOP
      END IF

4000  continue

      RETURN

*  +-------------------------------------------------------------------*
*  Exceptional exit, send and wait for end of computation
4200  continue

      write(LUNOUT,*) '** coupling.stop detected, ',
     &    'ending simulation'
      write(LUNOUT,*) "** Sending End Of Computation"

      N = NTSENDEOC(ICID)
      if(N.lt.0) then
        write(LUNOUT,*) 'Error sending end of turn'
        CALL FLUSH(LUNOUT)
        goto 3900
      end if

4500  continue

*     Wait for an end of computation message
      N = NTWAIT(
     &        ICID,
     &        MTYPE, 
     &        IDP, IDGEN, WGT, 
     &        XCBEAM, YCBEAM, ZCBEAM, 
     &        UCBEAM, VCBEAM, WCBEAM,
     &        IAA, IZZ, AMBEAM, PCBEAM,
     &        T)
      if(N.lt.0) then
        write(LUNOUT,*) 'Client timeout'
        CALL FLUSH(LUNOUT)
        goto 3900
      end if

      IF(MTYPE.NE.N_END) THEN
        goto 4500 ! Read next message
      end if

      goto 3800
*  +-------------------------------------------------------------------*

*=== End of subroutine Source =========================================*
      END
