#include <iostream>
#include <vector>
#include <string>
#include "Collimator.h"
#include "MagneticCollimator.h"
using namespace std;


/*
##############################################################################################################

can be used to debug some parts of the code (e.g. using integer values instead of doubles in some function)

The interest of this file is that it can be modified to see some special outputs of function without the
need to modify the real function integrated in the program and using the fact that this file is already
built in the makefile.

We have here three examples of tests of parts of the code with specifics parameters values which were done
using this file.

To run it, after the 'make' command, just type

./debug

##############################################################################################################
*/




double Bcalc(double x, double y, double z, double w)
{

    double percent, n;

    int nn;

    percent = 0.1;
    double a(log(percent));
    double b(log((y - z) / y));
    n = a / b;
    nn = (int)floor(n);
    if ((nn % 2) == 1) {
        n = floor(n);
    } else {
        n = ceil(n);
    }

    return (w * pow((x / y), n));
}

int main()
{

    //============================ DEBUGGING I: BeBloMuSca =======================================


    double ALFX(1.715332938);
    double ALFY(-2.070815068);
    double APER_1(0.04);
    double APER_2(0.04);
    double APER_3(0.04);
    double APER_4(0.04);
    string APERTYPE;
    APERTYPE = "RECTELLIPSE";
    double BETX(130.4920061);
    double BETY(145.9347602);
    double DPX(-0.032633675);
    double DPY(-0.005893863);
    double DX(2.182119904);
    double DY(-0.355863926);
    string KEYWORD;
    KEYWORD = "RCOLLIMATOR";
    double L(0.6);
    double MUX(16.31640483);
    double MUY(14.85010143);
    string NAME;
    NAME = "TCP.6L3.B1";
    double PTC(0);
    double PXC(4.43e-13);
    double PYC(-1.24e-12);
    double S(6487.9713);
    double TC(-1.64e-06);
    double XC(-7.94e-11);
    double YC(-7e-11);
    double K0L(0);
    double K0SL(0);
    double K1L(0);
    double K1SL(0);
    double K2L(0);
    double K2SL(0);
    string PARENT;
    PARENT =  "TCP";
    string meth;
    meth =  "standard";
    double hgap( 0.0038544149873210331);
    double hgap2( 0.0038544149873210331);
    double collang(-10);
    double pdepth(0);
    double pdepth2(0);
    double tcang(0);
    double nsig(15);
    double Bmax(2);
    double thicknessMagneticField(0.0001);
    double energyPerIon(574000);
    double mass(193.6872);
    double deltaGap(0.0000015);


    MagneticCollimator collim(ALFX, ALFY, APER_1, APER_2, APER_3, APER_4, APERTYPE, BETX, BETY, DPX, DPY, DX, DY, KEYWORD, L, MUX, MUY, NAME, PTC, PXC, PYC, S, TC, XC, YC, K0L, K0SL, K1L, K1SL, K2L, K2SL, PARENT, meth, hgap, hgap2, collang, pdepth, pdepth2, tcang, nsig, Bmax, thicknessMagneticField, energyPerIon, mass);

    collim.deltaGap = deltaGap;
    collim.material = "carbon";
    collim.crossSectionPath =  "crossSectionInfos/" + collim.material + '/';

    double wx(0);
    double wy(0);
    double dpopdx;
    double betgam(2963.5410461902575);
    string filename;
    filename = "crossSectionInfos/carbon/materialinfo.csv";
    double rho(1700);
    double s(0);
    double atarget(12.011);
    Particle p1(-9.62058e-07, -0.000153021, -4.97476e-05, -4.80766e-05, -8.21051e-05, 0, 208, 82,  -0.00012159388136310807);
    Particle p2(-2.29177e-05, -0.000135618, -6.02201e-05, 3.8913e-05, -6.28236e-05, 0, 208, 82,  -6.569201361245118e-05);

    collim.BeBloMuSca(wx, wy, dpopdx, betgam, filename, rho, collim.L - s, atarget, p1);

    cout << wx << endl;
    cout << wy << endl;
    cout << dpopdx << endl;


    //===================================== DEBUGGING II: MagneticCollimator::collipass  ====================================

    double dpopeff(-8.21051e-05);
    double scaleorbit(1);
    double dx(0.082457875);
    double dpx(-0.004199663);
    double dy(0.648364612);
    double dpy(-0.000636128);
    double delta_s(3214.988584 - 144.7);
    double Apr(208);
    double Zpr(82);


    collim.collipass(p1, dpopeff, scaleorbit, -1.2012125562536251, -164.13050747492346, -0.0043269348629002072, -1.4237130688947441, 0.66187442286836129, -226.98360345972108, 0.0036126697814305862, 0.2719295211935373, dx, dpx, dy, dpy, delta_s, Apr, Zpr, betgam);


    //====================================== DEBUGGING III: Bcalc ===================================================

    cout << Bcalc(4, 3, 1, 2) << endl;
    double(pdepthEnd);

    pdepthEnd = abs(1 + (5 - 2) * 4) - 6;

    cout << pdepthEnd << endl;


    return 0;
}
