#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <string>
using namespace std;

//##################################################################################################################

//This program can be used to transform a twiss file (output of MAD-X) into an opticsfile compatible with ICOSIM++

//##################################################################################################################


int main()
{

    string inputfile, outputfile;

    cout << "Please enter the name of the twiss file to convert: " << endl;

    cin >> inputfile;

    cout << "Enter now the desired name for the optics file : " << endl;

    cin >> outputfile;

    ifstream entree;
    ofstream sortie;

    entree.open(inputfile.c_str());
    sortie.open(outputfile.c_str());

    if (entree.fail()) {

        cerr << "Warning: problem opening the file " << inputfile << "!" << endl;

    } else if (sortie.fail()) {

        cerr << "Warning: problem with the file " << outputfile << "!" << endl;

    } else {

        char first;
        string param, indic;
        vector <string> temp;

        entree >> first;

        while (first == '@') {

            entree >> param;
            if (param == "NAME") {
                sortie << "NAMEFILE,";
            } else {
                sortie << param << ",";
            }
            entree >> indic;

            if (indic != "%le") {
                getline(entree, param);
                param = param.substr(2, param.size() - 3);
                sortie << param;
            } else {

                entree >> param;
                sortie << param;
            }

            sortie << endl;

            entree >> first;
        }

        int nbre(0);

        entree >> param;

        while (param != "$") {
            ++nbre;

            if ((param == "X") || (param == "PX") || (param == "Y") || (param == "PY") || (param == "T") || (param == "PT")) {
                param = param + "C";
            }

            temp.push_back(param);

            entree >> param;
        }

        for (int j(0); j < temp.size() - 1; ++j) {
            sortie << temp[j] << ",";
        }

        sortie << temp[temp.size() - 1] << endl;

        entree >> param;

        while (param.substr(0, 1) == "%") {
            entree >> param;
        }

        while (!entree.eof()) {

            for (int i(0); i < nbre - 1; ++i) {

                if (param.substr(0, 1)  == "\"") {
                    param = param.substr(1, param.size() - 2);
                }

                sortie << param << ",";
                entree >> param;
            }

            if (param.substr(0, 1)  == "\"") {
                param = param.substr(1, param.size() - 2);
            }

            sortie << param << endl;
            entree >> param;

        }

        int stop;
    }

    entree.close();
    sortie.close();

    return 0;
}
